#include <qapplication.h>
#include <qpushbutton.h>
#include <qlcdnumber.h>
#include <qfont.h>
#include <qlayout.h>
#include <iostream>
#include <math.h>
#include "GrWindow.h"
#define PRECISION 0.001
GrInit * GrInit::_myself=0;
SimplePlot * SimplePlot::_myself=0;
GrWindow::GrWindow( QWidget *parent, const char *name )
        : QWidget( parent, name )
{
    QPushButton *quit = new QPushButton( "Quit", this, "quit" );
    quit->setFont( QFont( "Times", 14, QFont::Bold ) );

    connect( quit, SIGNAL(clicked()), qApp, SLOT(quit()) );


    _da = new DrawArea(this,"grafico");

    grid = new QGridLayout( this, 2, 2, 2 );
    //2x2, 10 pixel border

    grid->addWidget( quit, 0, 0 );
    grid->addWidget( _da, 1, 1 );
    grid->setColStretch( 1, 10 );
//    
    setGeometry( 30, 30, XWINDOW+100, YWINDOW+40 );
    bgcolor=WHITE;
    fgcolor=BLUE;
    _paint= new QPainter( _da );
    _paint->setPen(fgcolor);
    _paint->setBackgroundColor(bgcolor);


};
void GrWindow::SetWindow(double x1, double x2,double y1, double y2,bool axis,bool centred) {
   extern int Axis_Room;
   xmin=x1;xmax=x2;ymin=y1;ymax=y2;
   Scale_FactorX=(XWINDOW-Axis_Room)/(x2-x1);
   Scale_FactorY=(YWINDOW-Axis_Room)/(y2-y1);
   X_Offset=-1.*x1*Scale_FactorX;
   Y_Offset=-1.*y1*Scale_FactorY;
   _axis=axis; _centred=centred;
   DrawAxis();


};

void GrFunction1D::Draw(GrOpt opt) {
   double x,y;
   SimplePlot * W=SimplePlot::get();
   if (opt!=SAME) {
      W->SetWindow(_xmin,_xmax+fabs((_xmax-_xmin)*0.05),_ymin,_ymax+fabs((_ymax-_ymin)*0.05));
   }
   x=_xmin;
   W->AddImage(fgcolor);
//   std::cout<<"GrFunction1D "<<W<<std::endl;
//       startpoint(x,y);
//  usa drawLine(x1,y1,x2,y2) di QPaint;
//      std::cout<<"draw "<<std::endl;
   for (int k=0; k<XWINDOW; k++) {
      y=me_stessa(x);
      W->plot(x,y);
      x+=_step;

   } 
};
void GrWindow::DrawAxis() {
         double stepX,stepY;
	 int label;
         if (_centred && _axis) {
	   _paint->setPen(RED);
           plot(xmin,0.,xmax,0.);
           plot(0.,ymin,0.,ymax);
	   _paint->setPen(fgcolor);
       }
        
/* se non sono richiesti gli assi esci */
       if (!_axis) return;
/* Scelgo colore assi  */       
       _paint->setPen(BLACK);
/* disegno asse X  con 10 tacche*/       
      /* asse  */
       _paint->drawLine(0,YWINDOW-Axis_Room,XWINDOW,YWINDOW-Axis_Room);
//       _paint->drawLine(0,YWINDOW-90,XWINDOW,YWINDOW-90);
       /* tacche e label */

//       std::cout<<"X"<<std::endl<<std::endl;
       stepX=(xmax-xmin)/10.;
       label=int(Axis_Room);
       double value=xmin;
       int esp=int(log10(fabs(value+stepX)));
       if (esp<0) esp--;
       for (int k=0; k<10; k++) {
         value+=stepX;;
	 double cvalue=value/pow(10,esp);
	 int cs=int(log10(fabs(cvalue)))-2;
	 cvalue=int(cvalue/pow(10,cs))*pow(10,cs);
//	 std::cout<<value<<" "<<esp<<" "<<cvalue<<std::endl;
         label+=int(stepX*Scale_FactorX);
	 _paint->drawLine(label,YWINDOW-Axis_Room,label,YWINDOW-int(Axis_Room/2));
	 QString s;
	 int xoff=-10;
	 if (esp!=0) {
	   s = QString::number( cvalue )+"E"+QString::number( esp );
	   xoff=-25;
	 }  
	 else s = QString::number( cvalue );
         _paint->drawText(label+xoff ,YWINDOW-Axis_Room+30, s );
       }

 /* disegno asse Y  con 10 tacche */       
      /* asse  */
       _paint->drawLine(Axis_Room,0,Axis_Room,YWINDOW);

      /* label */
/*        settextstyle(0,1,1);
       settextjustify(2,1);
       moveto(Axis_Room-10,YWINDOW-Axis_Room-20);
       sprintf(text,"%g\0",ymin);
       outtext(text);
       settextjustify(2,2);
       moveto(Axis_Room-10,3);
       sprintf(text,"%g\0",ymax);
       outtext(text);
       */
       /* tacche */
//       std::cout<<"Y"<<std::endl<<std::endl;
       stepY=(ymax-ymin)/10.;
       label=int(YWINDOW-Axis_Room);
       value=ymin;
       esp=int(log10(fabs(value+stepY)));
       if (esp<0) esp--;
       for (int k=0; k<10; k++) {
         value+=stepY;;
	 double cvalue=value/pow(10,esp);
	 int cs=int(log10(fabs(cvalue)))-2;
	 cvalue=int(cvalue/pow(10,cs))*pow(10,cs);
//	 std::cout<<value<<" "<<esp<<" "<<cvalue<<std::endl;

         label-=int(stepY*Scale_FactorY);
         _paint->drawLine(Axis_Room,label,int(Axis_Room/2),label);
	 QString s;
	 int xoff=0;
	 if (esp!=0) {
	   s = QString::number( cvalue )+"E"+QString::number( esp );
	   xoff=0;
	 }  
	 else s = QString::number( cvalue );
         _paint->drawText(Axis_Room-40,label+xoff , s );
       }


	   _paint->setPen(fgcolor);
	   return;
};

double (*Derivazione::func)(double)=0;
Derivazione::Derivazione(double (*f) (double x)){
     func=f;
     derivata=Derivazione::calcola;
}
double Derivazione::calcola(double x) {
      double h=fabs(sqrt(PRECISION)*x);
      if (h==0) h=sqrt(PRECISION);
      double den=func(x+h)-func(x-h);
      return den/2./h;
}
void JobEnd() {
     
/* chiusura finestra grafica   */
   SimplePlot * W = SimplePlot::get();
   W->exec();
//   system("PAUSE");
     
}

